<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Certificadores</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Certificadores</div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <div class="CampoOblogario">
              Certificador
              <span class="tRojo">*</span>
            </div>
            <v-autocomplete
              v-model="searchCertificador"
              :loading="isSearching"
              :items="metadata.certificadores"
              :search-input.sync="searchCertificadorSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="certificador_descripcion"
              @change="irCertificador"
              placeholder="Escribe su nombre o número de empleado"
              label="Buscar Certificador"
              solo
              return-object
            />
          </v-col>
          <v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <!--<v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchCertificador }
              ]"
              @click="getPuntoContacto()"
              >Buscar Certificador</v-btn
            >-->
          </v-col>
        </v-row>
      </div>

      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">
          Asignación de la franquicia
        </div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-buscadorCertificador",
  components: {},
  data() {
    return {
      serviceCommons,
      filtrosFechas: {},
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Revisión en Sitio",
          disabled: true,
        },
        {
          text: "Buscadores",
          disabled: true,
        },
        {
          text: "Por Certificadores",
          disabled: true,
        },
      ],
      searchCertificador: null,
      searchCertificadorSync: null,
      metadata: {
        certificadores: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: [],
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      isLoadingCertificadores: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      certificador: {
        id_certificador: null,
        nombre_certificador: null,
      },
    };
  },

  watch: {
    searchCertificadorSync(val) {
      if (!val) {
        this.searchCertificador = null;
        this.invokeDefaultEmpyDataCertificador();
      }
    },
  },
  computed: {},
  methods: {
    getPeridoInfo() {
      const self = this;
      axios
        .get("franquicia/periodo/secure/get/actual")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                //Se comenta el bimestre para traer solo fechas del trimestre.
                //PENDIENTE Parametrizar el periodo.
                data.bimestre = null;
                //data.trimestre = data.trimestre - 1;
                delete data.festivo;
                self.getFechasPeriodo(data);
              }else{
                self.filtrosFechas.fechaInicio = "01/01/2021";
                self.filtrosFechas.fechaFin = "31/03/2021";
                self.filtrosFechas.idNegocio = 1;
                self.getCertificadores();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getFechasPeriodo(periodo) {
      const self = this;
      axios
        .post("franquicia/periodo/secure/get/fechas", periodo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.filtrosFechas.fechaInicio = data.fecha_inicio;
                self.filtrosFechas.fechaFin = data.fecha_fin;
                //self.filtrosFechas.fechaInicio = "01/07/2020";
                 //self.filtrosFechas.fechaFin = "30/09/2020";
                self.filtrosFechas.idNegocio = 1;
                self.getCertificadores();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getCertificadores() {
      var self = this;
      self.isLoadingCertificadores = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/certificador")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCertificadores(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {
          self.isLoadingCertificadores = false;
        });
    },
    setCertificadores(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.certificador_descripcion =
            item.id_certificador + " - " + item.nombre_certificador;
          return item;
        });
      }
      this.metadata.certificadores = data;
    },
    setPuntoContacto(data) {
      data.asignacion.id_empleado = user.empleado;
      this.puntoContactoBackup = JSON.parse(JSON.stringify(data));
      this.puntoContacto = data;
    },
    cancelGlobalChanges() {
      this.puntoContacto = JSON.parse(JSON.stringify(this.puntoContactoBackup));
      this.isDialogCancel = false;
      this.$v.$reset();
    },
    snapshotDataPuntoContacto() {
      let certificador = JSON.stringify(this.certificador);
      this.defaultDataPuntoContacto = JSON.parse(certificador);
    },
    invokeDefaultEmpyDataCertificador() {
      let certificador = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.certificador = certificador;
      this.$v.$reset();
    },
    irCertificador() {
      if (this.searchCertificador) {
        this.$router.push({
          name: "certificacion_calidad_certificador_detalle",
          params: {
            certificador: serviceCommons.objectToBase64(this.searchCertificador),
            filtros: serviceCommons.objectToBase64(this.filtrosFechas)
          }
        });
      }
    },
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getPeridoInfo();
  },
};
</script>
